import os

import axipy
from PySide2.QtGui import QIcon
from axipy import Plugin, Position, view_manager

from ru_axioma_gis_report_marker.ui.dlgCreateMarkerInReport import CreateMarkertInReport
from ru_axioma_gis_report_marker.ui.tools.observer import factoryObserverManyPageReport


class MarkerInReport(Plugin):
    def __init__(self):
        super().__init__()
        self.__name = "Добавить маркеры в отчет"
        self.__form_tool = None
        self.__docWidget = None
        self._title = self.tr(self.__name)
        self.__name_observer="MultiPageReport"
        self.__observer=factoryObserverManyPageReport(self.__name_observer)
        local_file_icon_1 = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'ui/icons', 'report_marker.png')
        self.__icon_tools = QIcon(local_file_icon_1)
        self.__action = self.create_action(self.__name,
                                                      icon=local_file_icon_1, on_click=self.__run,enable_on=self.__name_observer)
        position = Position('Отчет', 'Операции')
        position.add(self.__action)



    def __run(self):
        size_marker=self.settings.value("SizeMarker")
        style_marker=self.settings.value("StyleMarker")
        if size_marker is not None or style_marker is not None:
            parm_marker={"size":int(size_marker),'style':style_marker}
        else:
            parm_marker=None
        cls_dlg=CreateMarkertInReport(parm_marker,axipy.mainwindow.widget)
        result=cls_dlg.exec_()
        if result[0] is not None:
            self.settings.setValue("SizeMarker",result[0])
            self.settings.setValue("StyleMarker", result[1])
    def unload(self) -> None:
        self.__action.remove()