import os

import axipy
from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog
from axipy import StyleButton, Style, LinearUnits

from ru_axioma_gis_report_marker.ui.tools.create_marker_in_report import createMarker
from ru_axioma_gis_report_marker.ui.tools.helperUnit import Distance


class CreateMarkertInReport(QDialog):
    def __init__(self,parm_default,parent=None):
        self.__size_marker = None
        self.__style_marker = None
        super().__init__(parent)
        self.__ui=self.load_ui("createMarkerInReport1.ui",parent)
        default_style='Pen (35, 2, 0)'
        try:
            default_style=parm_default['style']
        except:
            pass
        default_size=2
        try:
            default_size=parm_default['size']
        except:
            pass
        self.__ui.spinBox_size.setValue(default_size)
        self.__widgetStyle=StyleButton(Style.from_mapinfo(default_style),self.__ui)
        self.__ui.layout_style.addWidget(self.__widgetStyle)
        self.__ui.pb_create.clicked.connect(self.__create_markers)
        self.__ui.pb_close.clicked.connect(self.__close)
        self.__ui.finished.connect(self.__close)
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    def __create_markers(self):
        size_marker=Distance(self.__ui.spinBox_size.value(),LinearUnits.cm)
        style_marker=self.__widgetStyle.style
        createMarker(axipy.view_manager.active,size_marker,style_marker)
        self.__size_marker=size_marker.value
        self.__style_marker=style_marker.to_mapinfo()
        self.__ui.close()

    def __close(self):

        self.__ui.close()
        return self.__size_marker, self.__style_marker
    def exec_(self):
        self.__ui.exec_()
        return self.__size_marker, self.__style_marker
