from axipy import Style, Line, Pnt, GeometryCollection, GeometryReportItem

from ru_axioma_gis_report_marker.ui.tools.helperUnit import Distance


class MarkerReport:
    def __init__(self,size,style='Pen (1, 2, 0)'):
        self.__half_size_marker=size/2

        self.__style=Style.from_mapinfo(style)
    def create(self,xc,yc):
        #geo_item1=GeometryReportItem()
        x_0=xc-self.__half_size_marker
        x_1=xc+self.__half_size_marker
        #geo_item1.geometry=Line(Pnt(x_0,yc),Pnt(x_1,yc))
        #geo_item1.style=self.__stylev
        geometry_1 = Line(Pnt(x_0, yc), Pnt(x_1, yc))
        #geo_item2 = GeometryReportItem()
        y_0=yc-self.__half_size_marker
        y_1=yc+self.__half_size_marker
        #geo_item2.geometry = Line(Pnt(xc,y_0), Pnt(xc, y_1))
        #geo_item2.style = self.__style
        geometry_2 = Line(Pnt(xc, y_0), Pnt(xc, y_1))
        collection=GeometryCollection()
        collection.append(geometry_1)
        collection.append(geometry_2)
        geo_item = GeometryReportItem()
        #setattr(geo_item,"group_name","MarkerLabel")
        #geo_item.group="MarkerLabel"
        geo_item.geometry=collection
        geo_item.style=self.__style
        #return geo_item1,geo_item2
        return geo_item
def createMarker(active_report_view,size_marker:Distance,style:Style):
    report = active_report_view.report
    page_size = report.page_size
    unit = report.unit


    v_pages = report.vertical_pages
    h_page = report.horisontal_pages
    width_report = h_page * page_size.width()
    height_report = v_pages * page_size.height()
    page_report_width = width_report / h_page
    page_report_height = height_report / v_pages
    value_size=size_marker.to_unit(unit)
    cls_marker = MarkerReport(value_size, style.to_mapinfo())
    for i in range(h_page + 1):
        for j in range(v_pages + 1):
            xp_0 = i * page_report_width
            yp_0 = j * page_report_height
            items = cls_marker.create(xp_0, yp_0)
            report.items.add(items)